



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>K相邻算法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">K相邻算法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 04:10:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>刚开始学习机器学习,先跟这《机器学习实战》学一些基本的算法</p>
<p>----------------------------------分割线--------------------------------------------</p>
<p>该算法是用来判定一个点的分类,首先先找到离该点最近的k个点,然后找出这k个点的哪种分类出现次数最多,就把该点设为那个分类<br />距离公式选用欧式距离公式:</p>
<p><img referrerpolicy="no-referrer"src="http://images2017.cnblogs.com/blog/781708/201710/781708-20171009181355230-1227943123.png" /></p>
<p>下面给出例子(来自《机器学习实战》)</p>
<p>1.约会对象喜欢程度的判定:</p>
<p>现需要一个约会对象喜欢程度的分类器</p>
<p>给定数据集,属性包含</p>
<p>每年获得的飞行常客里程数,玩视频游戏所耗时间百分比,每周消费的冰淇淋公升数,是否喜欢且喜欢程度(不喜欢,一般喜欢,特别喜欢),四个属性</p>
<p>分类器代码:</p>
<p>先获取整个数据集的约会对象个数t,然后把我们要分类的矩阵复制t次</p>
<p>然后减去原数据集,得到xA0-xB0和xA1-xB1,然后对矩阵每个元素平方,行内求和,开根号,得到所有点的距离</p>
<p>统计前k个数据类别出现次数,返回次数最多的类别</p>
<div>
<pre class="prettyprint linenums"> def classify0(inX, dataSet, labels, k):
     dataSetSize = dataSet.shape[0]
     diffMat = tile(inX, (dataSetSize,1)) - dataSet
     sqDiffMat = diffMat**2
     sqDistances = sqDiffMat.sum(axis=1)
     distances = sqDistances**0.5
     sortedDistIndicies = distances.argsort()
     classCount={}
     for i in range(k):
         voteIlabel = labels[sortedDistIndicies[i]]
         classCount[voteIlabel] = classCount.get(voteIlabel,0) + 1
     sortedClassCount = sorted(classCount.iteritems(), key=operator.itemgetter(1), reverse=True)
     return sortedClassCount[0][0]</pre>
</div>
<p>先从文件中分别读前三个属性和喜欢程度到矩阵</p>
<p>然后进行归一化,最后分类得到结果统计一下就好了</p>
<div>
<pre class="prettyprint linenums"> def file2matrix(filename):
     fr = open(filename)
     numberOfLines = len(fr.readlines())         #get the number of lines in the file
     returnMat = zeros((numberOfLines,3))        #prepare matrix to return
     classLabelVector = []                       #prepare labels return
     fr = open(filename)
     index = 0
     for line in fr.readlines():
         line = line.strip()
         listFromLine = line.split('\t')
         returnMat[index,:] = listFromLine[0:3]
         classLabelVector.append(int(listFromLine[-1]))
         index += 1
     return returnMat,classLabelVector

 def autoNorm(dataSet):
     minVals = dataSet.min(0)
     maxVals = dataSet.max(0)
     ranges = maxVals - minVals
     normDataSet = zeros(shape(dataSet))
     m = dataSet.shape[0]
     normDataSet = dataSet - tile(minVals, (m,1))
     normDataSet = normDataSet/tile(ranges, (m,1))   #element wise divide
     return normDataSet, ranges, minVals

 def datingClassTest():
     hoRatio = 0.50      #hold out 10%
     datingDataMat,datingLabels = file2matrix('datingTestSet2.txt')       #load data setfrom file
     normMat, ranges, minVals = autoNorm(datingDataMat)
     m = normMat.shape[0]
     numTestVecs = int(m*hoRatio)
     errorCount = 0.0
     for i in range(numTestVecs):
         classifierResult = classify0(normMat[i,:],normMat[numTestVecs:m,:],datingLabels[numTestVecs:m],3)
         print "the classifier came back with: %d, the real answer is: %d" % (classifierResult, datingLabels[i])
         if (classifierResult != datingLabels[i]): errorCount += 1.0
     print "the total error rate is: %f" % (errorCount/float(numTestVecs))
     print errorCount</pre>
</div>
<p>2.数字识别</p>
<p>给定训练集包含32*32的01字符串,然后判定测试集的数字</p>
<p>对于把32*32每个数字都看作一个属性,然后直接算距离分类...</p>
<div>
<pre class="prettyprint linenums"> def img2vector(filename):
     returnVect = zeros((1,1024))
     fr = open(filename)
     for i in range(32):
         lineStr = fr.readline()
         for j in range(32):
             returnVect[0,32*i+j] = int(lineStr[j])
     return returnVect

 def handwritingClassTest():
     hwLabels = []
     trainingFileList = listdir('digits/trainingDigits')           #load the training set
     m = len(trainingFileList)
     trainingMat = zeros((m,1024))
     for i in range(m):
         fileNameStr = trainingFileList[i]
         fileStr = fileNameStr.split('.')[0]     #take off .txt
         classNumStr = int(fileStr.split('_')[0])
         hwLabels.append(classNumStr)
         trainingMat[i,:] = img2vector('digits/trainingDigits/%s' % fileNameStr)
     testFileList = listdir('digits/testDigits')        #iterate through the test set
     errorCount = 0.0
     mTest = len(testFileList)
     for i in range(mTest):
         fileNameStr = testFileList[i]
         fileStr = fileNameStr.split('.')[0]     #take off .txt
         classNumStr = int(fileStr.split('_')[0])
         vectorUnderTest = img2vector('digits/testDigits/%s' % fileNameStr)
         classifierResult = classify0(vectorUnderTest, trainingMat, hwLabels, 3)
         print "the classifier came back with: %d, the real answer is: %d" % (classifierResult, classNumStr)
         if (classifierResult != classNumStr): errorCount += 1.0
     print "\nthe total number of errors is: %d" % errorCount
     print "\nthe total error rate is: %f" % (errorCount/float(mTest))</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m96ol3y9.html">&lbrack;LeetCode&rsqb; Count The Repetitions 计数重复个数</a>
		</li>
						<li><a href="https://www.batexi.com/a/49g5rol8.html">Linux达人养成第一季</a>
		</li>
						<li><a href="https://www.batexi.com/a/3901odm8.html">玉伯的一道课后题题解（关于 IEEE 754 双精度浮点型精度损失）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxrr3eq.html">网页的title左边的小图片怎么添加</a>
		</li>
						<li><a href="https://www.batexi.com/a/wq16zp28.html">《K&amp;amp&semi;R》里贯穿全书的代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r2ngdq.html">js处理用户输入的银行卡号实现四位一段，并且只能输入数字</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlzko08.html">时间函数 date   strtotime</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvv47yq.html">经典DP 二维换一维</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmnp3k9.html">&lbrack;转&rsqb;float&comma;double和decimal类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm36w19.html">判断iPhone和iPad         判断设备版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/96oxv5v9.html">HTML5学习笔记-video</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jmzxl8.html">工厂模式在JS中的实践</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd53r49.html">map函数、filer函数、reduce函数的用法和区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpw5v39.html">Html &vert; Vue &vert; Element UI&mdash;&mdash;引入使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gj3nd09.html">Kafka学习之路</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlln061q.html">最小生成树入门（克鲁斯卡尔&plus;普利姆 hdu1233）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1l055q.html">Android-Java-子类实例化过程（内存图）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j3ek5q.html">hdu   6058---Kanade&amp;&num;39&semi;s sum（链表）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25lrovq.html">PL&sol;SQL Developer几个使用小技巧</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pyvxeq.html">【Eclipse】Eclipse常用操作</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/8kpkn2r9.html">JAVA实用案例之邮件发送</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdpgd1xq.html">chrome开发工具指南（七）</a>
			</li>
						<li><a href="https://www.batexi.com/a/90m4ejn8.html">ROS学习记录（一）&mdash;&mdash;&mdash;&mdash;创建简单的机器人模型smartcar</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjn04y8.html">mha 复制检查报错&OpenCurlyDoubleQuote;There is no alive server&period; We can&amp;&num;39&semi;t do failover&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96pl5238.html">汇编指令-MRS&lpar;读&rpar;和MSR&lpar;写&rpar;指令操作CPSR寄存器和SPSR寄存器使用&lpar;1&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ply648.html">【&amp;&num;9733&semi;】Web精彩实战之&amp;lt&semi;智能迷宫&amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljwvr09.html">JavaScript 的使用基础总结①</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y37408.html">JS内置对象-自定义对象</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjggmx8.html">集美大学网络1413第十次作业成绩（团队六） -- 展示博客（Alpha版本）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnjg44j8.html">201521123102 《Java程序设计》第6周学习总结</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
